<?php  
            include_once( $_SERVER['DOCUMENT_ROOT']."/static/includes/common.inc.php" );
            do_html_header("Documentation");
        ?><div id="content">
<div class="navheader">
<table width="100%" summary="Navigation header"><tr>
<td width="20%" align="left">
<a accesskey="p" href="cli-pegasus-transfer.php">Prev</a> </td>
<td width="60%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="20%" align="right"> <a accesskey="n" href="useful_tips.php">Next</a>
</td>
</tr></table>
<hr>
</div>
<div lang="en" class="refentry">
<a name="cli-pegasus-version"></a><div class="titlepage"></div>
<div class="refnamediv">
<h2>Name</h2>
<p>pegasus-version — print or match the version of the toolkit.</p>
</div>
<div class="refsynopsisdiv">
<a name="pegasus-version_synopsis"></a><h2>Synopsis</h2>
<div class="blockquote"><blockquote class="blockquote"><div class="literallayout"><p><span class="strong"><strong>pegasus-version</strong></span> [<span class="strong"><strong>-D</strong></span><span class="emphasis"><em>property=value</em></span>] [<span class="strong"><strong>-m</strong></span> [<span class="strong"><strong>-q</strong></span>]] [<span class="strong"><strong>-V</strong></span>] [<span class="strong"><strong>-f</strong></span>] [<span class="strong"><strong>-l</strong></span>]</p></div></blockquote></div>
</div>
<div class="refsect1">
<a name="pegasus-version_description"></a><h2>Description</h2>
<p>This program prints the version string of the currently active Pegasus
toolkit on <span class="emphasis"><em>stdout</em></span>.</p>
<p>pegasus-version is a simple command-line tool that reports the version
number of the Pegasus distribution being used. In its most basic invocation,
it will show the current version of the Pegasus software you have installed:</p>
<pre class="screen">$ pegasus-version
3.1.0cvs</pre>
<p>If you want to know more details about the installed version, i.e. which
system it was compiled for and when, use the long or full mode:</p>
<pre class="screen">$ pegasus-version -f
3.1.0cvs-x86_64_cent_5.6-20110706191019Z</pre>
</div>
<div class="refsect1">
<a name="pegasus-version_options"></a><h2>Options</h2>
<div class="variablelist"><dl class="variablelist">
<dt><span class="term">
<span class="strong"><strong>-D</strong></span><span class="emphasis"><em>property=value</em></span>
</span></dt>
<dd>
<p class="simpara">
The <span class="strong"><strong>-D</strong></span> option allows an experienced user to override certain properties
which influence the program execution, among them the default location of
the user’s properties file and the <span class="strong"><strong>PEGASUS_HOME</strong></span> location. One may set several
CLI properties by giving this option multiple times.
</p>
<p class="simpara">The <span class="strong"><strong>-D</strong></span> option(s) must be the first option on the command line. CLI properties
take precedence over the file-based properties of the same key.</p>
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-f</strong></span>
, </span><span class="term">
<span class="strong"><strong>--full</strong></span>
</span>
</dt>
<dd>
The <span class="strong"><strong>--full</strong></span> mode displays internal build metrics, like OS type and libc
version, addition to the version number. It appends the build time as
time stamp to the version. The time stamp uses ISO 8601 format, and is a
UTC stamp.
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-l</strong></span>
, </span><span class="term">
<span class="strong"><strong>--long</strong></span>
</span>
</dt>
<dd>
This option is an alias for <span class="strong"><strong>--full</strong></span>.
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-V</strong></span>
, </span><span class="term">
<span class="strong"><strong>--version</strong></span>
</span>
</dt>
<dd>
Displays the version of the Pegasus planner you are using.
</dd>
<dt><span class="term">
<span class="strong"><strong>--verbose</strong></span>
</span></dt>
<dd>
is ignored in this tool. However, to provide a uniform interface for all
tools, the option is recognized and will not trigger an error.
</dd>
</dl></div>
</div>
<div class="refsect1">
<a name="pegasus-version_return_value"></a><h2>Return Value</h2>
<p>The program will usually return with success (0). In match mode, if the
internal version does not match the external installation, an exit code
of 1 is returned. If run-time errors are detected, an exit code of 2 is
returned, 3 for fatal errors.</p>
</div>
<div class="refsect1">
<a name="pegasus-version_environment_variables"></a><h2>Environment Variables</h2>
<div class="variablelist"><dl class="variablelist">
<dt><span class="term">
<span class="strong"><strong>JAVA_HOME</strong></span>
</span></dt>
<dd>
should be set and point to a valid location to start the intended Java
virtual machine as <span class="emphasis"><em>$JAVA_HOME/bin/java</em></span>.
</dd>
</dl></div>
</div>
<div class="refsect1">
<a name="pegasus-version_example"></a><h2>Example</h2>
<pre class="screen">$ pegasus-version
3.1.0cvs

$ pegasus-version -f
3.1.0cvs-x86_64_cent_5.6-20110706191019Z</pre>
</div>
<div class="refsect1">
<a name="pegasus-version_authors"></a><h2>Authors</h2>
<p>Jens-S. Vöckler <code class="literal">&lt;voeckler at isi dot edu&gt;</code></p>
<p>Pegasus Team <a class="ulink" href="http://pegasus.isi.edu" target="_top">http://pegasus.isi.edu</a></p>
</div>
</div>
<div class="navfooter">
<hr>
<table width="100%" summary="Navigation footer">
<tr>
<td width="40%" align="left">
<a accesskey="p" href="cli-pegasus-transfer.php">Prev</a> </td>
<td width="20%" align="center"><a accesskey="u" href="cli.php">Up</a></td>
<td width="40%" align="right"> <a accesskey="n" href="useful_tips.php">Next</a>
</td>
</tr>
<tr>
<td width="40%" align="left" valign="top">pegasus-transfer </td>
<td width="20%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="40%" align="right" valign="top"> Chapter 16. Useful Tips</td>
</tr>
</table>
</div>
</div><?php  
            do_html_footer();
        ?>
